Subject: Re: [PATCH v10 0/7] Support Trusted Foundations firmware on Tegra30

From: Thierry Reding <[email-masked]>
Date: Tue, 9 Apr 2019 16:42:19 +0200

On Mon, Mar 18, 2019 at 01:52:03AM +0300, Dmitry Osipenko wrote:
> Hello,
> 
> This patchset adds support for the Trusted Foundations firmware on
> NVIDIA Tegra30. Pretty much all of Tegra30 consumer devices have that
> firmware and upstream kernel can't boot on those devices without the
> firmware support. This series was tested on Nexus 7, TF300T and Ouya
> Tegra30 devices.
> 
> Changelog:
> 
> v10:    - Removed duplicated message about keeping L2C disabled when
>           CONFIG_TRUSTED_FOUNDATIONS=n as was suggested by Michał Mirosław
>           in the review comment to v9.
> 
> v9:     - Rebased on recent linux-next, resolved one conflict.
> 
> v8:     - Replaced BIT() macro with a definition provided by cache-l2x0.h
>           in the "Support L2 cache maintenance" patch as was suggested by
>           Russell King in the review comment to v7.
> 
> v7:     - Fixed kernel booting with CONFIG_TRUSTED_FOUNDATIONS=n by
>           providing a dummy L2C write_sec implementation in the
>           "Support L2 cache maintenance" patch.
> 
>         - Minor clean up: no static variables anymore, replaced
>           white spaces with a tab in one place, etc.
> 
>         - Added Michał's and Robert's Tested-by/Signed-off-by to the
>           patches.
> 
> v6:     - One patch got messed up accidentally in v5, this is fixed now.
> 
>         - Squashed "Support L2 cache maintenance done via firmware" patch
>           into the "Add firmware calls..." patch.
> 
>         - The l2x0_init() firmware callback is now invoked unconditionally
>           because it is always a NO-OP on T114+ and is a NO-OP on T20/30
>           if firmware node is missed in device-tree, hence there is no
>           need to check the machine's DT compatible as it was done in the
>           previous versions of the series.
> 
> v5:     - Fixed machine hanging on disabling D-cache during suspend,
>           turned out there are slight variations in behaviour between
>           firmware version in regards to cache-management. Thanks to
>           Robert Yang for reporting the problem and helping with the
>           solution.
> 
> v4:     - Fixed Thumb2-kernel hanging on Tegra20, turned out it was not a
>           good idea to switch CPU into Thumb2 mode right after jumping into
>           the reset handler.
> 
>         - Moved LP2-mode-set firmware call invocation to a later stage to
>           better replicate what downstream kernel does. This change was
>           suggested by Robert Yang and fixes system hang on Ouya game
>           console.
> 
>         - Added references to the original work made by Michał Mirosław
>           into commit messages of the relevant patches.
> 
> v3:     - Implemented suspend-resume support.
> 
>         - Reworked arm/firmware/trusted_foundations.c a tad. Now cache
>           is getting properly initialized, cache enabling / disabling is
>           supported.
> 
> v2:
>         - The "Don't apply CPU erratas in insecure mode" patch got some
>           cleanup, in particular resolved the messiness in
>           __tegra_cpu_reset_handler_data.
> 
>         - Added a comment to tf_cache_write_sec(), justifying the warning
>           message.
> 
> Dmitry Osipenko (7):
>   ARM: trusted_foundations: Support L2 cache maintenance
>   ARM: trusted_foundations: Make prepare_idle call to take mode argument
>   ARM: trusted_foundations: Provide information about whether firmware
>     is registered
>   ARM: tegra: Set up L2 cache using Trusted Foundations firmware
>   ARM: tegra: Don't apply CPU erratas in insecure mode
>   ARM: tegra: Always boot CPU in ARM-mode
>   ARM: tegra: Add firmware calls required for suspend-resume on Tegra30
> 
>  arch/arm/firmware/trusted_foundations.c    | 75 +++++++++++++++++++++-
>  arch/arm/include/asm/firmware.h            |  2 +-
>  arch/arm/include/asm/trusted_foundations.h | 23 +++++++
>  arch/arm/mach-tegra/cpuidle-tegra114.c     |  3 +-
>  arch/arm/mach-tegra/pm.c                   | 49 ++++++++++++++
>  arch/arm/mach-tegra/reset-handler.S        | 50 +++++++++++----
>  arch/arm/mach-tegra/reset.c                |  3 +
>  arch/arm/mach-tegra/reset.h                |  9 ++-
>  arch/arm/mach-tegra/sleep-tegra20.S        |  4 ++
>  arch/arm/mach-tegra/sleep.S                | 14 ++--
>  arch/arm/mach-tegra/tegra.c                |  2 +
>  11 files changed, 212 insertions(+), 22 deletions(-)

Hi Russell,

I've picked these up into the Tegra tree so that they can get more
exposure. Let me know if you have any objections to me carrying these in
the Tegra tree.

Thanks,
Thierry
_______________________________________________
linux-arm-kernel mailing list
[email-masked]
http://lists.infradead.org/mailman/listinfo/linux-arm-kernel